=== debian/changelog ===
mlpack (3.4.2-5ubuntu1) jammy; urgency=medium

  * Drop erroneous ${python3:Versions} dependency
  * Skip dh_dwz due to errors with LLVM 14

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 11 Apr 2022 14:55:20 +0000

mlpack (3.4.2-5build1) jammy; urgency=medium

  * No-change rebuild to fix wrong dep.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 07 Apr 2022 22:55:51 +0000

mlpack (3.4.2-5) unstable; urgency=medium

  * Restrict build dependency on libomp-dev to architectures using clang

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 18 Feb 2022 10:08:27 +0000

mlpack (3.4.2-4) unstable; urgency=medium

  * Cherry-pick zoq:atomic-llvm 26855cd348c04c345fa6bf57aa8c33d0b181d396

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 17 Feb 2022 14:00:24 +0000

mlpack (3.4.2-3) unstable; urgency=medium

  * Disable building tests, per email suggestion from Curtis
  * Build dependency so OpenMP will actually be used

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 15 Feb 2022 19:28:14 +0000

mlpack (3.4.2-2) unstable; urgency=medium

  * Bump policy
  * Just install the entire Doxygen-generated html directory willy-nilly
  * Export vars in debian/rules for new dh_python3 ${DEB_HOST_ARCH} error
  * Remove lintian override for obsolete tag hyphen-used-ad-minus-sign
  * Remove copyright stanza for long-removed ARMA cmake files
  * Add some substitution variables that are being defined

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 03 Feb 2022 14:21:59 +0000

mlpack (3.4.2-1) unstable; urgency=medium

  * New upstream version
  * Forward port patches
  * Do not allow doxygen warnings to break the build

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 03 Nov 2020 22:19:04 +0000
