=== debian/watch ===
version=4
https://www.mlpack.org/files/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
